
Cube = /net/koko/bob/bin/LINUX/cube_sep


gou = min1=0.3 max1=1.3 min2=4000 max2=7000 grid=y g1num=0.1 g2num=200

R = Fig

RESULTSER = # figure names
RESULTSCR =  modData RTM DIcom sparseRTM sparseDeep# figure names
RESULTSNR =  illum forward reverse Flowchart # figure names


rmfig: 
	rm -f Fig/*.pdf Fig/*.ps

Figures: $R/modData.pdf $R/RTM.pdf $R/DIcom.pdf $R/sparseRTM.pdf $R/sparseDeep.pdf
	cp Input/*.pdf $R/.



#--------------------------------------------------------------------------------------------------------

gpar = >/dev/null title=' ' titlesz=8 titlefat=1 labelrot=y labelfat=2 labelsz=6 wheretitle=t n1tic=5 n2tic=5 crowd=0.75 whereylabel=l wherexlabel=b wheretics=f 

#$R/modData.pdf: CallmodData
$R/modData.pdf:
	< Data/sdF320.H Window3d n3=1 f3=0 | Transp | Grey $(gpar) screenratio=1.5 title='a)'  label1='time(s)'  label2='x(m)' out=$R/junk1.v
	Math file1=Data/sdF320.H exp='-1*file1' > Data/sdF320b.H
	< Data/sdF320b.H Window3d n3=1 f3=1 | Transp | Grey $(gpar) screenratio=1.5 title='b)' wantaxis1=0 label2='x(m)' out=$R/junk2.v	
	vppen < Fig/junk1.v vpstyle=n align=lu >1.v
	vppen < Fig/junk2.v vpstyle=n xshift=6 > 2.v
	vppen 1.v 2.v erase=n scale=0.54 > $R/modData.v
	pstexpen   $R/modData.v  ${R}/modData.ps fat=5 famult=7 invras=y color=y scale=0.9
	epstopdf $R/modData.ps	
	rm -f Fig/junk1.v Fig/junk2.v 1.v 2.v 

#--------------------------------------------------------------------------------------------------------	
	
gpar2 = >/dev/null title=' ' titlesz=9 titlefat=1 labelrot=y labelfat=2 labelsz=9 wheretitle=t n1tic=5 n2tic=5 crowd=0.75 whereylabel=l wherexlabel=b wheretics=f 
#$R/RTM.pdf:  CallRTM
$R/RTM.pdf:
	< Data/upRTM.H  Grey $(gpar2) title='a)' titlesz=20 labelsz=15 label1='z(m)' wantaxis2=0  screenratio=0.29 crowd=0.70 out=$R/junk1.v
	< Data/dnRTM.H Grey $(gpar2) title='b)' titlesz=20 labelsz=15 label1='z(m)' wantaxis2=0  screenratio=0.29  crowd=0.70 out=$R/junk2.v
	< Data/mFTotaliter20.H Grey $(gpar2) title='b)' titlesz=20 labelsz=15 label1='z(m)' wantaxis2=0  screenratio=0.29  crowd=0.70 out=$R/junk3.v
	< Data/refl1.H Grey $(gpar2) title='c)' titlesz=20 labelsz=15 label1='z(m)' label2='x(m)' screenratio=0.29 crowd=0.70  out=$R/junk4.v
	vppen <Fig/junk1.v vpstyle=n align=lu yshift=27.5  > 1.v
	vppen <Fig/junk2.v vpstyle=n align=lu yshift=18.5  > 2.v	
	vppen <Fig/junk3.v vpstyle=n align=lu yshift=9.5 > 3.v	
	vppen <Fig/junk4.v vpstyle=n align=lu yshift=0.5 > 4.v		
	vppen 1.v 2.v 3.v 4.v erase=n scale=0.14 > Fig/RTM.v
	pstexpen   $R/RTM.v  ${R}/RTM.ps fat=3 famult=5 invras=y color=y scale=0.9
	epstopdf $R/RTM.ps			
	rm -f Fig/junk1.v Fig/junk2.v Fig/junk3.v Fig/junk4.v 1.v 2.v 3.v 4.v	



#--------------------------------------------------------------------------------------------------------
	
gpar0 = >/dev/null title=' ' titlesz=12 titlefat=1 labelrot=y labelfat=2 labelsz=12 wheretitle=t  crowd=0.70 whereylabel=l wherexlabel=b wheretics=f 
	
$R/DIcom.pdf: $R/RTM.pdf
	< Data/upRTM.H Window3d n1=100 f1=50 | Window3d n2=300 f2=200 | Grey $(gpar0) title='a)'  label1='z(m)' wantaxis2=0 w pclip=90 out=$R/junk1.v
	< Data/dnRTM.H Window3d n1=100 f1=50 | Window3d n2=300 f2=200 | Grey $(gpar0) title='b)' wantaxis1=0 wantaxis2=0 pclip=90  out=$R/junk2.v
	< Data/refl1.H Window3d n1=100 f1=50 | Window3d n2=300 f2=200 | Grey $(gpar0) title='d)' wantaxis1=0 label2='x(m)' pclip=90  out=$R/junk4.v
	< Data/mFTotaliter20.H Window3d n1=100 f1=50 | Window3d n2=300 f2=200 | Grey $(gpar0)  label1='z(m)' label2='x(m)'  pclip=90  title='c)' out=$R/junk3.v
	vppen < Fig/junk1.v vpstyle=n xshift=0 yshift=9 > 1.v
	vppen < Fig/junk2.v vpstyle=n xshift=11 yshift=9 > 2.v	
	vppen < Fig/junk3.v vpstyle=n xshift=0 yshift=0 > 3.v
	vppen < Fig/junk4.v vpstyle=n xshift=11 yshift=0 > 4.v	
	vppen 1.v 2.v 3.v 4.v erase=n scale=0.2 > $R/DIcom.v
	pstexpen   $R/DIcom.v  ${R}/DIcom.ps fat=4 famult=7 invras=y color=y scale=0.9
	epstopdf $R/DIcom.ps	


#--------------------------------------------------------------------------------------------------------

gpar3 = >/dev/null title=' ' titlesz=9 titlefat=1 labelrot=y labelfat=1 labelsz=9 wheretitle=t n1tic=5 n2tic=5 crowd=0.75 whereylabel=l wherexlabel=b wheretics=f

# $R/sparseRTM.pdf: CallsparseRTM
$R/sparseRTM.pdf: 
	< Data/sparseRTM.H  Window3d n3=1 f3=0 | Grey $(gpar3) title='a)' titlesz=20 labelsz=15 label1='z(m)' wantaxis2=0  screenratio=0.29 crowd=0.70 out=junk1.v
	< Data/sparseRTM.H  Window3d n3=1 f3=1 | Grey $(gpar3) title='b)' titlesz=20 labelsz=15 label1='z(m)' wantaxis2=0  screenratio=0.29  crowd=0.70 pclip=98 out=junk2.v
	
	< Data/mKTotaliter21.H Grey $(gpar3) title='c)' titlesz=20 labelsz=15 label1='z(m)' wantaxis2=0 screenratio=0.29 crowd=0.70  out=junk3.v
	< Data/reflnew.H Grey $(gpar3) title='d)' titlesz=20 labelsz=15 label1='z(m)' label2='x(m)' screenratio=0.29 crowd=0.70  out=junk4.v
	vppen <junk1.v vpstyle=n align=lu yshift=27.5  > 1.v
	vppen <junk2.v vpstyle=n align=lu yshift=18.5  > 2.v	
	vppen <junk3.v vpstyle=n align=lu yshift=9.5 > 3.v	
	vppen <junk4.v vpstyle=n align=lu yshift=0.5 > 4.v		
	vppen 1.v 2.v 3.v 4.v erase=n scale=0.14 > $R/sparseRTM.v
	pstexpen $R/sparseRTM.v  $R/sparseRTM.ps fat=3 famult=5 invras=y color=y scale=0.9
	epstopdf $R/sparseRTM.ps			
	rm -f junk1.v junk2.v junk3.v junk4.v 4.v 1.v 2.v 3.v 


#--------------------------------------------------------------------------------------------------------
	
gpar4 = >/dev/null title=' ' titlesz=12 titlefat=1 labelrot=y labelfat=1 labelsz=12 wheretitle=t  crowd=0.70 whereylabel=l wherexlabel=b wheretics=f pclip=99
	
$R/sparseDeep.pdf: $R/sparseRTM.pdf
	< Data/sparseRTM.H  Window3d n3=1 f3=0 | Window3d n1=100 f1=50 | Window3d n2=300 f2=200 | Grey $(gpar4) title='a)'  label1='z(m)' wantaxis2=0 w  out=junk1.v
	< Data/sparseRTM.H  Window3d n3=1 f3=1 | Window3d n1=100 f1=50 | Window3d n2=300 f2=200 | Grey $(gpar4) title='b)' wantaxis1=0 wantaxis2=0   out=junk2.v
	< Data/mKTotaliter21.H Window3d n1=100 f1=50 | Window3d n2=300 f2=200 | Grey $(gpar4) label1='z(m)' label2='x(m)'   title='c)'  out=junk3.v
	< Data/reflnew.H  Window3d n1=100 f1=50 | Window3d n2=300 f2=200 | Grey $(gpar4) title='d)' wantaxis1=0 label2='x(m)' out=junk4.v
	vppen < junk1.v vpstyle=n xshift=0 yshift=9 > 1.v
	vppen < junk2.v vpstyle=n xshift=11 yshift=9 > 2.v	
	vppen < junk3.v vpstyle=n xshift=0 yshift=0 > 3.v
	vppen < junk4.v vpstyle=n xshift=11 yshift=0 > 4.v	
	vppen 1.v 2.v 3.v 4.v erase=n scale=0.2 > $R/sparseDeep.v
	pstexpen $R/sparseDeep.v  $R/sparseDeep.ps fat=4 famult=5 invras=y color=y scale=0.9
	epstopdf $R/sparseDeep.ps
	
#--------------------------------------------------------------------------------------------------------	


######################## Generic rule ##########################################

%.ps: %.v 
	pstexpen   $*.v  $*.ps fat=5 famult=7 invras=y color=y scale=0.9
        #vplot2eps fat=5 invras=y $*.v  $*.eps
        # Other options:   big=y force=n

%.pdf: %.ps
	epstopdf $<


