#! /usr/bin/env python
#from SEP import *
import commands as cmd
import re,string
import sys, os
import os.path as path
import fileinput


#############################################################################

def Adjoint(maindir, dirrr,dirdm,bshot,eshot,osx,dsx,iter):
	Nproc=5
	flag=1	
	for i in range(bshot,eshot+1):
		os.system("sleep 2")	
		shot = osx + (i-1)*dsx	
		submitted = 0
		while (submitted == 0):
			# flag = number of job running
			os.system("ps >&"+maindir+"/file.log")
			flag = os.system("grep -c 'LsqMig_Main' "+maindir+"/file.log >&"+maindir+"/count.txt")
			f = open(maindir+'/count.txt')
			os.system("rm -f "+maindir+"/file.log "+maindir+"/count.txt")
			flag = int(f.readline())	
#			print 'Adjoint: number of proc found', flag, 'iter', iter	
		
			if (flag < Nproc):
				print 'Adjoint: submitting shot #', shot
				cmd1 = "bin/LsqMig_Main.x velin='Input/vel2500.H' par=Par/Adjmar.par shotnum=%s nt=3000 bndz=200 bndx=200 inv=0 wfldsou='souwfld/swB%s.H' recfile=%s%siter%s.H outtag=%s%siter%s.H >&%s/dm/logfile/dm%s.log &"%(shot,shot,dirrr,shot,iter,dirdm,shot,iter,maindir,shot)
				os.system(cmd1)
				submitted = 1
			else:
				# print 'Number of proc',flag,'wait 20'
				os.system("sleep 20")
				
	flag=4


	while (flag > 0):
#		print "not done yet, sleep 20"
		os.system("sleep 20")	
		os.system("ps >&"+maindir+"/filesg.log")	
		flag = os.system("grep -c 'LsqMig_Main' "+maindir+"/filesg.log >&"+maindir+"/countsg.txt")
		f = open(maindir+'/countsg.txt')
		flag = int(f.readline())
		print 'number of process found', flag
		os.system("rm -f "+maindir+"/countsg.txt "+maindir+"/filesg.log")

	print 'Adjoint for iter # ',iter,' is done, now is summing'
		
	return


############################################################################################################

def Forward(maindir,dirdm, dirgg, bshot,eshot,osx,dsx,iter):
	Nproc=5
	flag=1	
	for i in range(bshot,eshot+1):
		os.system("sleep 3")	
		shot = osx + (i-1)*dsx	
		submitted = 0
		while (submitted == 0):
			# flag = number of job running
			os.system("ps >&"+maindir+"/file.log")
			flag = os.system("grep -c 'Forward' "+maindir+"/file.log >&"+maindir+"/count.txt")
			f = open(maindir+'/count.txt')
			os.system("rm -f "+maindir+"/file.log "+maindir+"/count.txt")
			flag = int(f.readline())	
#			print 'Forward: number of proc found', flag, 'iter #', iter	
		
			if (flag < Nproc):
				print 'Forward: submitting shot #', shot
				cmd1 = "bin/Forward.x velin='Input/vel2500.H' par=Par/formar.par nt=3000 bndz=200 bndx=200 shotnum=%s wfldsou='souwfld/swB%s.H' reflfile=%sTotaliter%s.H outtag=%s%siter%s.H >&%s/gg/logfile/gg%s.log &"%(shot,shot,dirdm,iter,dirgg,shot,iter,maindir,shot)
				print cmd1
																
				os.system(cmd1)
				submitted = 1
			else:
				# print 'Number of proc',flag,'wait 20'
				os.system("sleep 20")
				
	flag=4


	while (flag > 0):
#		print "not done yet, sleep 20"
		os.system("sleep 20")	
		os.system("ps >&"+maindir+"/filesg.log")	
		flag = os.system("grep -c 'Forward' "+maindir+"/filesg.log >&"+maindir+"/countsg.txt")
		f = open(maindir+'/countsg.txt')
		flag = int(f.readline())
		print 'number of process found', flag
		os.system("rm -f "+maindir+"/countsg.txt "+maindir+"/filesg.log")

	print 'Forward for iter # ',iter,' is done'
		
	return

		
		
	


# ####################################


def Add(d1,  iter, nblock, dboc, osx, dsx):
        d1BK=d1+"BK"
	for block in range(1,nblock):
     		print 'Block #', block 
        	i = (block-1)*5+1
        	shot = osx+ (i-1)*dsx
    		print 'summing dm files for block ', block 
    		cmd1 = "bin/SUMMING.x nfile=%s naxis=2 outfile=%s%s.H file1=%s%siter%s.H file2=%s%siter%s.H file3=%s%siter%s.H file4=%s%siter%s.H file5=%s%siter%s.H file6=%s%siter%s.H file7=%s%siter%s.H file8=%s%siter%s.H file9=%s%siter%s.H file10=%s%siter%s.H >/dev/null"%(dboc, d1BK,block,d1,shot,iter,d1,shot+dsx,iter,d1,shot+2*dsx,iter,d1,shot+3*dsx,iter,d1,shot+4*dsx,iter,d1,shot+5*dsx,iter,d1,shot+6*dsx,iter,d1,shot+7*dsx,iter,d1,shot+8*dsx,iter,d1,shot+9*dsx,iter)
    		print cmd1
    		os.system(cmd1)

  		
                 	  	  	  	
	# Sum all the block to form a big model  
	print 'summing files for all blocks'
	if (nblock == 2):
		cmd1 = "cp %s1.H %sTotaliter%s.H"%(d1BK, d1,iter)
		os.system(cmd1)
	else: 
		cmd1 = "bin/SUMMING.x nfile=%s naxis=2 outfile=%sTotaliter%s.H file1=%s1.H file2=%s2.H file3=%s3.H file4=%s4.H file5=%s5.H file6=%s6.H file7=%s7.H file8=%s8.H file9=%s9.H file10=%s10.H >/dev/null"%(nblock-1, d1, iter, d1BK, d1BK, d1BK, d1BK, d1BK, d1BK, d1BK, d1BK, d1BK, d1BK)
		print cmd1
		os.system(cmd1) 
	
	return
           	  	  	  	

# ####################################	
	
def DPcal(filein):
	sum=0.0
	for line in fileinput.input(filein):
		sum = sum + float(line)
#		print sum, float(line)
	os.system("rm -f "+filein)
	return sum

# ####################################	
# Calculate the alpha only using double precision

def DPcalCG(maindir,bshot,eshot,osx,dsx,iter):
	p = re.compile('[0-9][^ \t\n\r\f\v]*[0-9]')
	ggdgg = 0.
	ggdrr = 0.
	resid = 0.
	for i in range(bshot, eshot+1):
		shot = osx + (i-1)*dsx
		# calculating ggdgg 
		os.system('rm -f '+maindir+'/temp.txt')
		cmd1 = "Solver_ops file1=%s/gg/ggF%siter%s.H op=dot >&%s/temp.txt"%(maindir,shot,iter,maindir)
		os.system(cmd1)	
		f2 = open(maindir+'/temp.txt', 'r')
		str1 = f2.readline()
		m = p.search(str1)
		ggdgg = ggdgg + float(m.group())
		# Calculating ggdrr
		os.system('rm -f '+maindir+'/temp.txt')
		cmd1 = "Solver_ops file1=%s/gg/ggF%siter%s.H file2=%s/rr/rrF%siter%s.H op=dot >&%s/temp.txt"%(maindir,shot,iter,maindir,shot,iter,maindir)
		os.system(cmd1)	
		f2 = open(maindir+'/temp.txt', 'r')
		str1 = f2.readline()
		m = p.search(str1)
		ggdrr = ggdrr + float(m.group())
		# calculating rrdrr
		os.system('rm -f '+maindir+'/temp.txt')
		cmd1 = "Solver_ops file1=%s/rr/rrF%siter%s.H op=dot >&%s/temp.txt"%(maindir,shot,iter,maindir)
		os.system(cmd1)	
		f2 = open(maindir+'/temp.txt', 'r')
		str1 = f2.readline()
		m = p.search(str1)
		resid = resid + float(m.group())
	os.system("rm -f "+maindir+"/alpha.txt")
	os.system("bin/modcgstep.x Forget=1 ggdgg="+`ggdgg`+" ggdrr="+`ggdrr`+" outtag='"+maindir+"/alpha.txt' >/dev/null ")
	f = open(maindir+"/alpha.txt")
	alpha = float(f.readline())	
	beta = 0.
	
	return alpha, beta, resid

# ####################################	
# Calculate the alpha and beta using double precision

def DPcalCD(maindir, bshot,eshot,osx,dsx,iter):
	p = re.compile('[0-9][^ \t\n\r\f\v]*[0-9]')
	ggdrr = 0.
	ggdgg = 0.
	ssdss = 0.
	ssdrr = 0.
	ssdgg = 0.
	resid = 0.
	for i in range(bshot, eshot+1):
		shot = osx + (i-1)*dsx
		# calculating ggdgg 
		os.system('rm -f '+maindir+'/temp.txt')
		cmd1 = "Solver_ops file1=%s/gg/ggF%siter%s.H op=dot >&%s/temp.txt"%(maindir,shot,iter,maindir)
		os.system(cmd1)	
		f2 = open(maindir+'/temp.txt', 'r')
		str1 = f2.readline()
		m = p.search(str1)
		ggdgg = ggdgg + float(m.group())
		# Calculating ggdrr
		os.system('rm -f '+maindir+'/temp.txt')
		cmd1 = "Solver_ops file1=%s/gg/ggF%siter%s.H file2=%s/rr/rrF%siter%s.H op=dot >&%s/temp.txt"%(maindir,shot,iter,maindir,shot,iter,maindir)
		os.system(cmd1)	
		f2 = open(maindir+'/temp.txt', 'r')
		str1 = f2.readline()
		m = p.search(str1)
		ggdrr = ggdrr + float(m.group())
		# calculating ssdss
		os.system('rm -f '+maindir+'/temp.txt')
		cmd1 = "Solver_ops file1=%s/ss/ssF%siter%s.H op=dot >&%s/temp.txt"%(maindir,shot,iter,maindir)
		os.system(cmd1)	
		f2 = open(maindir+'/temp.txt', 'r')
		str1 = f2.readline()
		m = p.search(str1)
		ssdss = ssdss + float(m.group())	
		# calculating rrdrr
		os.system('rm -f '+maindir+'/temp.txt')
		cmd1 = "Solver_ops file1=%s/rr/rrF%siter%s.H op=dot >&%s/temp.txt"%(maindir,shot,iter,maindir)
		os.system(cmd1)	
		f2 = open(maindir+'/temp.txt', 'r')
		str1 = f2.readline()
		m = p.search(str1)
		resid = resid + float(m.group())
		# Calculating ssdrr
		os.system('rm -f '+maindir+'/temp.txt')
		cmd1 = "Solver_ops file1=%s/ss/ssF%siter%s.H file2=%s/rr/rrF%siter%s.H op=dot >&%s/temp.txt"%(maindir,shot,iter,maindir,shot,iter,maindir)
		os.system(cmd1)	
		f2 = open(maindir+'/temp.txt', 'r')
		str1 = f2.readline()
		m = p.search(str1)
		ssdrr = ssdrr + float(m.group())
		# Calculating ssdgg
		os.system('rm -f '+maindir+'/temp.txt')
		cmd1 = "Solver_ops file1=%s/ss/ssF%siter%s.H file2=%s/gg/ggF%siter%s.H op=dot >&%s/temp.txt"%(maindir,shot,iter,maindir,shot,iter,maindir)
		os.system(cmd1)	
		f2 = open(maindir+'/temp.txt', 'r')
		str1 = f2.readline()
		m = p.search(str1)
		ssdgg = ssdrr + float(m.group())
	
	
	os.system("rm -f "+maindir+"/alpha.txt")
	cmd1 = "bin/modcgstep.x Forget=0 ggdgg=%s ggdrr=%s ssdss=%s ssdrr=%s ssdgg=%s outtag='%s/alpha.txt' >/dev/null "%(ggdgg,ggdrr,ssdss,ssdrr,ssdgg,maindir)
	os.system(cmd1)
	f = open(maindir+"/alpha.txt")
	alpha = float(f.readline())
	beta  = float(f.readline())	

	return alpha, beta, resid

# ####################################
	
def dotprodCG(d1, ns):
	os.system("bin/dotproduct.x same=1 file1="+d1+"/rr/rrD"+`ns`+"iter1.H outtag="+d1+"/DPrrdrr.txt >/dev/null")
	os.system("bin/dotproduct.x same=1 file1="+d1+"/gg/ggD"+`ns`+"iter1.H outtag="+d1+"/DPggdgg.txt >/dev/null")
	os.system("bin/dotproduct.x file1="+d1+"/gg/ggD"+`ns`+"iter1.H file2="+d1+"/rr/rrD"+`ns`+"iter1.H outtag="+d1+"/DPggdrr.txt >/dev/null")
	return

def dotprod(d1, ns, iter):
	os.system("bin/dotproduct.x same=1 file1="+d1+"/rr/rrD"+`ns`+"iter"+`iter`+".H   outtag="+d1+"/DPrrdrr.txt >/dev/null")	
	os.system("bin/dotproduct.x same=1 file1="+d1+"/gg/ggD"+`ns`+"iter"+`iter`+".H   outtag="+d1+"/DPggdgg.txt >/dev/null")	
	os.system("bin/dotproduct.x same=1 file1="+d1+"/ss/ssD"+`ns`+"iter"+`iter`+".H   outtag="+d1+"/DPssdss.txt >/dev/null")
	os.system("bin/dotproduct.x file1="+d1+"/gg/ggD"+`ns`+"iter"+`iter`+".H   file2="+d1+"/rr/rrD"+`ns`+"iter"+`iter`+".H  outtag="+d1+"/DPggdrr.txt >/dev/null")	
	os.system("bin/dotproduct.x file1="+d1+"/rr/rrD"+`ns`+"iter"+`iter`+".H   file2="+d1+"/ss/ssD"+`ns`+"iter"+`iter`+".H  outtag="+d1+"/DPssdrr.txt >/dev/null")	
	os.system("bin/dotproduct.x file1="+d1+"/gg/ggD"+`ns`+"iter"+`iter`+".H   file2="+d1+"/ss/ssD"+`ns`+"iter"+`iter`+".H  outtag="+d1+"/DPssdgg.txt >/dev/null")	
	return
	
# ###################################

def removefiles(maindir,nblock,dboc,osx,dsx,iter,nitersave,saveshot):
	d1BK = maindir +"/dm/dmFBK"
	dirgg = maindir + "/gg/ggF"
	dirss = maindir + "/ss/ssF"
	dirrr = maindir + "/rr/rrF"
	dirs  = maindir + "/s/sF"
	dirm  = maindir + "/m/mF"
	dirdm = maindir + "/dm/dmF"
	os.system("rm -f "+maindir+"/alpha.txt")
	
	for i in range(1,(nblock-1)*dboc+1):
		shot = osx + (i-1)*dsx
		# Erase all the dmD%.H file after each BK is calculated
  		os.system("Rm -f "+dirdm+`shot`+"iter"+`iter`+".H ") 

  	# Erase all the dmDBK%.H file after Total is calculated
		os.system("Rm -f "+d1BK+"*.H")

	
	# Erase old rr, gg, and ss, unless request to be saved    
#	for i in range(1,(nblock-1)*dboc+1):
#		shot = osx + (i-1)*dsx
#		os.system("Rm -f "+dirgg+`shot`+"iter"+`iter`+".H ")
#		os.system("Rm -f "+dirss+`shot`+"iter"+`iter`+".H ")
#		if ((iter%nitersave == 0) & (shot != saveshot)):
#			os.system("Rm -f "+dirrr+`shot`+"iter"+`iter`+".H ")
	
	# Erase old m, dm, and s
#	os.system("Rm -f "+dirs+"Total"+"iter"+`iter`+".H ")
#	if (iter%nitersave == 0):
#		os.system("Rm -f "+dirm+"Total"+"iter"+`iter`+".H "+dirdm+"Total"+"iter"+`iter`+".H ")
			
	return		
