#! /usr/bin/env python
#from SEP import *
import commands as cmd
import re,string
import sys, os
import os.path as path



import pyAddmodF 
import pyfirstiterF


maindir = "20shots/L2"
dirm = maindir + "/m/mF"
dirdm = maindir + "/dm/dmF"
dirs = maindir + "/s/sF"
dirgg = maindir + "/gg/ggF"
dirss = maindir + "/ss/ssF"
dirrr = maindir + "/rr/rrF"

####### Iteration loop #############
biter = 2
eiter = 20
####################################

nblock=4+1
dboc = 5
osx = 250
dsx = 10
bshot=1
eshot = (nblock-1)*dboc
saveshot = (osx+((nblock-1)*dboc)*dsx)/2
nitersave = 2 


os.system("make bin/modcgstep.x")
os.system("make bin/LsqMig_Main.x")
os.system("make bin/Forward.x")
os.system("make bin/updateAB.x")

if (biter == 2):
	pyfirstiterF.run(maindir,nblock,dboc,dsx,osx)

for iter in range(biter,eiter+1):
	print 'Running iteration#', iter
	
	# Step 2: Loop shots  dm = F'Rd
	if (iter != -1*biter):
		pyAddmodF.Adjoint(maindir,dirrr, dirdm, bshot,eshot,osx,dsx,iter)

        # Step 3: Calculate dmTotal	
	if (iter != -1*biter):
		pyAddmodF.Add(dirdm,iter, nblock,dboc, osx,dsx)
	   
	# Step 4: Loop shots  gg = Fdm        
	if (iter != -1*biter):
		pyAddmodF.Forward(maindir, dirdm, dirgg, bshot,eshot,osx,dsx,iter)
			        
        
        
        # Step 5: Calculate the alpha and beta in conjugate direction
        alpha, beta, resid = pyAddmodF.DPcalCD(maindir, bshot,eshot,osx,dsx,iter)
	print alpha, beta, resid
	file = open(maindir+'/Reportsave.txt', 'a')
	cmd1 = " %s %s %s %s \n"%(iter,alpha,beta, resid)
	file.writelines(cmd1);
	file.close()
	
	
	#  Step 6: Update the residual files
        for i in range(bshot,eshot+1):
                shot = osx + (i-1)*dsx
                print 'residual update, iter', iter, 'shot', shot
                #  calculate your ss file ss=alpha*dr+beta*ss	
                C1 = "bin/updateAB.x alpha=%s beta=%s naxis=3 file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s%siter%s.H >/dev/null"%(alpha,beta,dirgg,shot,iter,dirss,shot,iter,dirss,shot,iter+1)
		os.system(C1)
			             
		#  update your current residual here  rr=rr+ss
		C1 = "bin/updateAB.x alpha=1.0 beta=1.0 naxis=3 file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s%siter%s.H >/dev/null"%(dirrr,shot,iter,dirss,shot,iter+1,dirrr,shot,iter+1)
		os.system(C1)

	
	# Step 7: Update the model files
	# Calculate your new dm s=alpha*dm+beta*s
	print 'model update, iter', iter
	C1 = "bin/updateAB.x alpha=%s beta=%s naxis=2 file1=%sTotaliter%s.H file2=%sTotaliter%s.H outfile=%sTotaliter%s.H >/dev/null"%(alpha,beta,dirdm,iter,dirs,iter,dirs,iter+1)	
	os.system(C1)  
	# Calculate your new m
	C1 = "bin/updateAB.x alpha=1.0 beta=1.0 naxis=2 file1=%sTotaliter%s.H file2=%sTotaliter%s.H outfile=%sTotaliter%s.H >/dev/null"%(dirm,iter,dirs,iter+1,dirm,iter+1)	
	os.system(C1)
       
        # Step 9, remove files
#	pyAddmodF.removefiles(maindir,nblock,dboc,osx,dsx,iter,nitersave,saveshot)
